Bring your own CA for mTLS
This page explains how you can manage client certificates that have not been issued by Cloudflare CA. For a broader overview, refer to the mTLS at Cloudflare learning path.
Bring your own CA (BYOCA) is especially useful if you already have mTLS implemented and client certificates are already installed on devices.
- This feature is only available on Enterprise accounts.
- Each Enterprise account can upload up to five CAs. This quota does not apply to CAs uploaded through Cloudflare Access.
When you upload your CA, Cloudflare validates the certificate according to certain requirements.
-
The CA certificate can be from a publicly trusted CA or self-signed.
-
In the certificate
Basic Constraints, the attributeCAmust be set toTRUE. -
The certificate must use one of the signature algorithms listed below:
Allowed signature algorithms
x509.SHA1WithRSAx509.SHA256WithRSAx509.SHA384WithRSAx509.SHA512WithRSAx509.ECDSAWithSHA1x509.ECDSAWithSHA256x509.ECDSAWithSHA384x509.ECDSAWithSHA512
-
In the Cloudflare dashboard, go to the Client Certificates page.
Go to Client Certificates -
Select Add Certificate.
-
In the Certificate Authority dropdown, select Bring your own CA.
-
Upload your CA certificate file (PEM encoded) and enter a name for the CA.
-
Select Continue.
-
On the Associate Hostnames page, enter the hostname that should use this CA for mTLS validation and select Add for each one. You can also skip this step and associate hostnames later.
-
Select Save to confirm.
- Use the Upload mTLS certificate endpoint to upload the CA root certificate.
-
caboolean required- Set to
trueto indicate that the certificate is a CA certificate.
- Set to
-
certificatesstring required- Insert content from the
.pemfile associated with the CA certificate, formatted as a single string with\nreplacing the line breaks.
- Insert content from the
-
namestring optional- Indicate a unique name for your CA certificate.
-
private_keystring optional- Insert content from the
.pemfile associated with the private key for the certificate, formatted as a single string with\nreplacing the line breaks.
- Insert content from the
- Take note of the certificate ID (
id) that is returned in the API response. - Use the Replace Hostname Associations endpoint to enable mTLS in each hostname that should use the CA for mTLS validation. Use the following parameters:
-
hostnamesarray required-
List the hostnames that will be using the CA for client certificate validation.
-
-
mtls_certificate_idstring required-
Indicate the certificate ID obtained from the previous step.
-
- (Optional) Make a GET request to confirm the CA hostname associations.
After uploading the CA and associating hostnames, create a custom rule to enforce client certificate validation. You can do this via the dashboard or via API.
"expression": "(http.host in {\"<HOSTNAME_1>\" \"<HOSTNAME_2>\"} and not cf.tls_client_auth.cert_verified)", "action": "block"There can be multiple CAs (Cloudflare-managed or BYOCA) associated with the same hostname. For BYOCA certificates, the most recently deployed certificate will be prioritized.
If you wish to remove the association from the Cloudflare-managed certificate and only use your BYOCA certificate(s):
-
In the Cloudflare dashboard, go to the Client Certificates page.
Go to Client Certificates -
On the Hosts section under Cloudflare-issued Client Certificates, select Edit.
-
Select the cross next to the hostname you want to remove.
-
Select Save to confirm.
- List the hostname associations without the
mtls_certificate_idparameter.
Required API token permissions
At least one of the following token permissions
is required:
SSL and Certificates WriteSSL and Certificates Read
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/certificate_authorities/hostname_associations" \ --request GET \ --header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"- Copy the
hostnamesarray returned by the API and update it, removing the hostname that should no longer use the Cloudflare-managed CA. - Use the Replace Hostname Associations endpoint without the
mtls_certificate_idparameter to perform the action against the Cloudflare-managed CA. Forhostnamesuse the list from the previous step.
Required API token permissions
At least one of the following token permissions
is required:
SSL and Certificates Write
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/certificate_authorities/hostname_associations" \ --request PUT \ --header "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \ --json '{ "hostnames": [ "<UPDATED_HOSTNAME_ASSOCIATIONS>" ] }'If you want to remove a CA that you have previously uploaded, you must first remove any hostname associations that it has.
-
In the Cloudflare dashboard, go to the Client Certificates page.
Go to Client Certificates -
Select the BYOCA tab.
-
Find the CA you want to delete and select the three dots next to it.
-
Remove all associated hostnames first, if any exist.
-
Select the delete option and confirm.
- Make a request to the Replace Hostname Associations endpoint, with an empty array for
hostnamesand specifying your CA certificate ID inmtls_certificate_id:
"hostnames": [], "mtls_certificate_id": "<CERTIFICATE_ID>"- Use the Delete mTLS certificate endpoint to delete the certificate.
-
In the Cloudflare dashboard, go to the Client Certificates page.
Go to Client Certificates -
Select the BYOCA tab.
-
Find the CA you want to inspect and select the three dots next to it.
-
Select Edit hostnames. The Certificate Details panel displays the associated hostnames.
Use the List Hostname Associations endpoint with the mtls_certificate_id query parameter set to the certificate ID of the uploaded CA.
Required API token permissions
At least one of the following token permissions
is required:
SSL and Certificates WriteSSL and Certificates Read
curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/certificate_authorities/hostname_associations?mtls_certificate_id=ID_FROM_STEP_2" \ --request GET \ --header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"